Index: src/Parser/parser.h
===================================================================
--- src/Parser/parser.h	(revision 148f7290b223b10641c960429cd37cc278a5903c)
+++ src/Parser/parser.h	(revision 43385ca81ad774a9c833abcd37fa12d82fd1c49c)
@@ -1,18 +1,18 @@
-/* A Bison parser, made by GNU Bison 3.0.2.  */
+/* A Bison parser, made by GNU Bison 2.5.  */
 
 /* Bison interface for Yacc-like parsers in C
-
-   Copyright (C) 1984, 1989-1990, 2000-2013 Free Software Foundation, Inc.
-
+   
+      Copyright (C) 1984, 1989-1990, 2000-2011 Free Software Foundation, Inc.
+   
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.
-
+   
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
-
+   
    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
@@ -27,134 +27,126 @@
    Bison output files to be licensed under the GNU General Public
    License without this special exception.
-
+   
    This special exception was added by the Free Software Foundation in
    version 2.2 of Bison.  */
 
-#ifndef YY_YY_PARSER_PARSER_H_INCLUDED
-# define YY_YY_PARSER_PARSER_H_INCLUDED
-/* Debug traces.  */
-#ifndef YYDEBUG
-# define YYDEBUG 1
-#endif
-#if YYDEBUG
-extern int yydebug;
-#endif
-
-/* Token type.  */
+
+/* Tokens.  */
 #ifndef YYTOKENTYPE
 # define YYTOKENTYPE
-  enum yytokentype
-  {
-    TYPEDEF = 258,
-    AUTO = 259,
-    EXTERN = 260,
-    REGISTER = 261,
-    STATIC = 262,
-    INLINE = 263,
-    FORTRAN = 264,
-    CONST = 265,
-    VOLATILE = 266,
-    RESTRICT = 267,
-    FORALL = 268,
-    LVALUE = 269,
-    VOID = 270,
-    CHAR = 271,
-    SHORT = 272,
-    INT = 273,
-    LONG = 274,
-    FLOAT = 275,
-    DOUBLE = 276,
-    SIGNED = 277,
-    UNSIGNED = 278,
-    ZERO_T = 279,
-    ONE_T = 280,
-    VALIST = 281,
-    BOOL = 282,
-    COMPLEX = 283,
-    IMAGINARY = 284,
-    TYPEOF = 285,
-    LABEL = 286,
-    ENUM = 287,
-    STRUCT = 288,
-    UNION = 289,
-    OTYPE = 290,
-    FTYPE = 291,
-    DTYPE = 292,
-    TRAIT = 293,
-    SIZEOF = 294,
-    OFFSETOF = 295,
-    ATTRIBUTE = 296,
-    EXTENSION = 297,
-    IF = 298,
-    ELSE = 299,
-    SWITCH = 300,
-    CASE = 301,
-    DEFAULT = 302,
-    DO = 303,
-    WHILE = 304,
-    FOR = 305,
-    BREAK = 306,
-    CONTINUE = 307,
-    GOTO = 308,
-    RETURN = 309,
-    CHOOSE = 310,
-    DISABLE = 311,
-    ENABLE = 312,
-    FALLTHRU = 313,
-    TRY = 314,
-    CATCH = 315,
-    CATCHRESUME = 316,
-    FINALLY = 317,
-    THROW = 318,
-    THROWRESUME = 319,
-    AT = 320,
-    ASM = 321,
-    ALIGNAS = 322,
-    ALIGNOF = 323,
-    ATOMIC = 324,
-    GENERIC = 325,
-    NORETURN = 326,
-    STATICASSERT = 327,
-    THREADLOCAL = 328,
-    IDENTIFIER = 329,
-    QUOTED_IDENTIFIER = 330,
-    TYPEDEFname = 331,
-    TYPEGENname = 332,
-    ATTR_IDENTIFIER = 333,
-    ATTR_TYPEDEFname = 334,
-    ATTR_TYPEGENname = 335,
-    INTEGERconstant = 336,
-    CHARACTERconstant = 337,
-    STRINGliteral = 338,
-    REALDECIMALconstant = 339,
-    REALFRACTIONconstant = 340,
-    FLOATINGconstant = 341,
-    ZERO = 342,
-    ONE = 343,
-    ARROW = 344,
-    ICR = 345,
-    DECR = 346,
-    LS = 347,
-    RS = 348,
-    LE = 349,
-    GE = 350,
-    EQ = 351,
-    NE = 352,
-    ANDAND = 353,
-    OROR = 354,
-    ELLIPSIS = 355,
-    MULTassign = 356,
-    DIVassign = 357,
-    MODassign = 358,
-    PLUSassign = 359,
-    MINUSassign = 360,
-    LSassign = 361,
-    RSassign = 362,
-    ANDassign = 363,
-    ERassign = 364,
-    ORassign = 365,
-    ATassign = 366,
-    THEN = 367
-  };
+   /* Put the tokens into the symbol table, so that GDB and other debuggers
+      know about them.  */
+   enum yytokentype {
+     TYPEDEF = 258,
+     AUTO = 259,
+     EXTERN = 260,
+     REGISTER = 261,
+     STATIC = 262,
+     INLINE = 263,
+     FORTRAN = 264,
+     CONST = 265,
+     VOLATILE = 266,
+     RESTRICT = 267,
+     FORALL = 268,
+     LVALUE = 269,
+     VOID = 270,
+     CHAR = 271,
+     SHORT = 272,
+     INT = 273,
+     LONG = 274,
+     FLOAT = 275,
+     DOUBLE = 276,
+     SIGNED = 277,
+     UNSIGNED = 278,
+     ZERO_T = 279,
+     ONE_T = 280,
+     VALIST = 281,
+     BOOL = 282,
+     COMPLEX = 283,
+     IMAGINARY = 284,
+     TYPEOF = 285,
+     LABEL = 286,
+     ENUM = 287,
+     STRUCT = 288,
+     UNION = 289,
+     OTYPE = 290,
+     FTYPE = 291,
+     DTYPE = 292,
+     TRAIT = 293,
+     SIZEOF = 294,
+     OFFSETOF = 295,
+     ATTRIBUTE = 296,
+     EXTENSION = 297,
+     IF = 298,
+     ELSE = 299,
+     SWITCH = 300,
+     CASE = 301,
+     DEFAULT = 302,
+     DO = 303,
+     WHILE = 304,
+     FOR = 305,
+     BREAK = 306,
+     CONTINUE = 307,
+     GOTO = 308,
+     RETURN = 309,
+     CHOOSE = 310,
+     DISABLE = 311,
+     ENABLE = 312,
+     FALLTHRU = 313,
+     TRY = 314,
+     CATCH = 315,
+     CATCHRESUME = 316,
+     FINALLY = 317,
+     THROW = 318,
+     THROWRESUME = 319,
+     AT = 320,
+     ASM = 321,
+     ALIGNAS = 322,
+     ALIGNOF = 323,
+     ATOMIC = 324,
+     GENERIC = 325,
+     NORETURN = 326,
+     STATICASSERT = 327,
+     THREADLOCAL = 328,
+     IDENTIFIER = 329,
+     QUOTED_IDENTIFIER = 330,
+     TYPEDEFname = 331,
+     TYPEGENname = 332,
+     ATTR_IDENTIFIER = 333,
+     ATTR_TYPEDEFname = 334,
+     ATTR_TYPEGENname = 335,
+     INTEGERconstant = 336,
+     CHARACTERconstant = 337,
+     STRINGliteral = 338,
+     REALDECIMALconstant = 339,
+     REALFRACTIONconstant = 340,
+     FLOATINGconstant = 341,
+     ZERO = 342,
+     ONE = 343,
+     ARROW = 344,
+     ICR = 345,
+     DECR = 346,
+     LS = 347,
+     RS = 348,
+     LE = 349,
+     GE = 350,
+     EQ = 351,
+     NE = 352,
+     ANDAND = 353,
+     OROR = 354,
+     ELLIPSIS = 355,
+     MULTassign = 356,
+     DIVassign = 357,
+     MODassign = 358,
+     PLUSassign = 359,
+     MINUSassign = 360,
+     LSassign = 361,
+     RSassign = 362,
+     ANDassign = 363,
+     ERassign = 364,
+     ORassign = 365,
+     ATassign = 366,
+     THEN = 367
+   };
 #endif
 /* Tokens.  */
@@ -270,10 +262,13 @@
 #define THEN 367
 
-/* Value type.  */
+
+
+
 #if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
-typedef union YYSTYPE YYSTYPE;
-union YYSTYPE
+typedef union YYSTYPE
 {
-#line 120 "parser.yy" /* yacc.c:1909  */
+
+/* Line 2068 of yacc.c  */
+#line 120 "parser.yy"
 
 	Token tok;
@@ -292,14 +287,15 @@
 	bool flag;
 
-#line 295 "Parser/parser.h" /* yacc.c:1909  */
-};
+
+
+/* Line 2068 of yacc.c  */
+#line 293 "Parser/parser.h"
+} YYSTYPE;
 # define YYSTYPE_IS_TRIVIAL 1
+# define yystype YYSTYPE /* obsolescent; will be withdrawn */
 # define YYSTYPE_IS_DECLARED 1
 #endif
 
-
 extern YYSTYPE yylval;
 
-int yyparse (void);
-
-#endif /* !YY_YY_PARSER_PARSER_H_INCLUDED  */
+