Index: doc/bibliography/pl.bib
===================================================================
--- doc/bibliography/pl.bib	(revision 251454a0e3b1ae4d72977259113f6d571fa93f03)
+++ doc/bibliography/pl.bib	(revision 46782ab58bed66a4c516ae5102dbb9066e2dd60e)
@@ -1183,14 +1183,4 @@
 	that is ``compiled''.
     },
-    comment	= {
-        Imagine the program, including the subroutines, spread out over a
-	table, with the compiler dropping Jello on the parts as they are
-	compiled.  At first little drops appear in seemingly random places.
-	These get bigger and combine with other drops to form growing
-	globs.  When two globs meet, ripples will go out through each as
-	they adjust to each other's presence, although the parts of the
-	globs that formed first are less affected by the ripples.  When
-	compilation is complete, there is one congealed mass.
-    }
 }
 
@@ -1388,7 +1378,6 @@
 	Process-valued expressions and process variables.  Processes have
 	execution priority: Create {\em process-type-name}(args) [with
-	priority(p)], 
-	and the priority can be changed on the fly.  Complicated guard/
-	screen structure on accept: accept {\em transaction}(param names)
+	priority(p)], and the priority can be changed on the fly.  Complicated
+	guard/screen structure on accept: accept {\em transaction}(param names)
 	[suchthat (exp)] [by (exp)] [compoundstatement].  Accepts cannot
 	appear in functions!  Can specify timeouts on transaction calls.
@@ -1833,12 +1822,11 @@
 }
 
-@article{Moore75,
-    keywords	= {approximation methods, integrated circuits},
-    contributer	= {pabuhr@plg},
-    author	= {Gordon E. Moore},
-    title	= {Progress in Digital Integrated Electronics},
-    journal	= {Technical Digest, International Electron Devices Meeting, IEEE},
-    year	= 1975,
-    pages	= {11-13},
+@misc{CS343,
+    keywords	= {uC++ teaching},
+    contributer	= {pabuhr@plg},
+    key		= {Peter Buhr},
+    title	= {CS343},
+    year	= 2017,
+    howpublished= {\href{https://www.student.cs.uwaterloo.ca/~cs343}{https://\-www.student.cs.uwaterloo.ca/\-~cs343}},
 }
 
@@ -2568,4 +2556,17 @@
     year	= 1979,
     pages	= {24-32}
+}
+
+@inproceedings{XaaS,
+    keywords	= {Everything as a Service, Anything as a Service, Cloud computing, SOA},
+    contributer	= {pabuhr@plg},
+    author	= {Duan, Yucong and Fu, Guohua and Zhou, Nianjun and Sun, Xiaobing and Narendra, Nanjangud C. and Hu, Bo},
+    title	= {Everything As a Service (XaaS) on the Cloud: Origins, Current and Future Trends},
+    booktitle	= {Proceedings of the 2015 IEEE 8th International Conference on Cloud Computing},
+    series	= {CLOUD'15},
+    year	= {2015},
+    pages	= {621--628},
+    publisher	= {IEEE Computer Society},
+    address	= {Washington, DC, USA},
 }
 
@@ -2779,6 +2780,9 @@
     title	= {Extending Modula-2 to Build Large, Integrated Systems},
     journal	= {IEEE Software},
-    month	= nov, year = 1986,
-    volume	= 3, number = 6, pages = {46-57},
+    month	= nov,
+    year	= 1986,
+    volume	= 3,
+    number	= 6,
+    pages	= {46-57},
     comment	= {
     	Exceptions can have a parameter.  Procedures can declare the
@@ -4893,12 +4897,12 @@
 }
 
-@techreport{OpenMP,
+@manual{OpenMP,
     keywords	= {concurrency, openmp, spmd},
     contributer	= {pabuhr@plg},
-    author	= {OpenMP Architecture Review Board},
-    title	= {OpenMP Application Program Interface, Version 4.0},
-    month	= jul,
-    year	= 2013,
-    note	= {\href{http://www.openmp.org/mp-documents/OpenMP4.0.0.pdf}{http://\-www.openmp.org/\-mp-documents/\-OpenMP4.0.0.pdf}},
+    key		= {OpenMP},
+    title	= {OpenMP Application Program Interface, Version 4.5},
+    month	= nov,
+    year	= 2015,
+    note	= {\href{https://www.openmp.org/wp-content/uploads/openmp-4.5.pdf}{https://\-www.openmp.org/\-wp-content/\-uploads/\-openmp-4.5.pdf}},
 }
 
@@ -5753,10 +5757,19 @@
 }
 
+@article{Moore75,
+    keywords	= {approximation methods, integrated circuits},
+    contributer	= {pabuhr@plg},
+    author	= {Gordon E. Moore},
+    title	= {Progress in Digital Integrated Electronics},
+    journal	= {Technical Digest, International Electron Devices Meeting, IEEE},
+    year	= 1975,
+    pages	= {11-13},
+}
+
 @article{promises,
     keywords	= {futures, Argus, call streams, rpc},
     contributer	= {gjditchfield@plg},
     author	= {Barbara Liskov and Liuba Shrira},
-    title	= {Promises: Linguistic Support for Efficient Asynchronous
-	  Procedure Calls in Distributed Systems},
+    title	= {Promises: Linguistic Support for Efficient Asynchronous Procedure Calls in Distributed Systems},
     journal	= sigplan,
     year	= 1988,